#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>

// Ƌ`\\
struct LINE {
	int pos1X,pos1Y,pos2X,pos2Y;
	LINE(): pos1X(0),pos1Y(0),pos2X(0),pos2Y(0) {}
	LINE(int sx,int sy,int dx,int dy): pos1X(sx),pos1Y(sy),pos2X(dx),pos2Y(dy) {}
};

struct SQUARE {
	int pos1X,pos1Y,pos2X,pos2Y;
	SQUARE(): pos1X(0),pos1Y(0),pos2X(0),pos2Y(0) {}
	SQUARE(int sx,int sy,int dx,int dy): pos1X(sx),pos1Y(sy),pos2X(dx),pos2Y(dy) {}
};

// W\\
struct COORD {
	int x,y;
	COORD(): x(0),y(0) {}
	COORD(int ix,int iy): x(ix),y(iy) {}
};

// [Iȓ񎟌z𓮓IɊmۂ邽߂̃NX
template<class T>
class virtual_2d_array {
	T* buffer;
	size_t x_size,y_size;
	public:
		virtual_2d_array() {
			buffer=new T[1];
			x_size=y_size=1;
		}
		~virtual_2d_array() {delete[] buffer;}
		// vf[y][x]Ɏw肷
		void resize(size_t y,size_t x) {
			delete[] buffer;
			buffer=new T[x*y];
			x_size=x;
			y_size=y;
		}
		virtual_2d_array(size_t y,size_t x) {
			buffer=new T[1];
			resize(y,x);
		}
		T* operator[](size_t idx) {return buffer+x_size*idx;}
		const T* operator[](size_t idx) const {return buffer+x_size*idx;}
		// z̗vfŜw肵lŖ߂
		void fill_all(const T& value) {
			std::fill(buffer,buffer+x_size*y_size,value);
		}
};

// 񎟌BIT̃NX
class bit_2d {
	virtual_2d_array<int> bit2d_table;
	size_t bit_max_x,bit_max_y;

	void internal_add(int* array,size_t pos,int value) {
		pos++;
		while(pos<=bit_max_x) {
			array[pos-1]+=value;
			pos+=pos & (-pos);
		}
	}

	int internal_sum(const int* array,size_t pos) const {
		int sum=0;
		pos++;
		while(pos>0) {
			sum+=array[pos-1];
			pos-=pos & (-pos);
		}
		return sum;
	}

	public:
		// 
		void clear() {
			bit2d_table.fill_all(0);
		}
		// vfݒ肷
		void resize(size_t y_size,size_t x_size) {
			bit2d_table.resize(y_size,x_size);
			bit_max_x=x_size;
			bit_max_y=y_size;
		}
		bit_2d(): bit_max_x(0),bit_max_y(0) {}
		bit_2d(size_t y_size,size_t x_size) {
			resize(y_size,x_size);
		}

		// (x,y)value
		void add(size_t x,size_t y,int value) {
			y++;
			while(y<=bit_max_y) {
				internal_add(bit2d_table[y-1],x,value);
				y+=y & (-y);
			}
		}

		// [0,x]~[0,y]̘a߂
		int sum(size_t x,size_t y) const {
			int sum=0;
			y++;
			while(y>0) {
				sum+=internal_sum(bit2d_table[y-1],x);
				y-=y & (-y);
			}
			return sum;
		}

		// [sx,dx)~[sy,dy)valueh(@)
		void add2(int sx,int sy,int dx,int dy,int value) {
			if(sx<0)sx=0;
			if(sy<0)sy=0;
			if(sx>=(int)bit_max_x || sy>=(int)bit_max_y)return;
			add(sx,sy,value);
			if(dx<(int)bit_max_x)add(dx,sy,-value);
			if(dy<(int)bit_max_y)add(sx,dy,-value);
			if(dx<(int)bit_max_x && dy<(int)bit_max_y)add(dx,dy,value);
		}

		// [sx,dx)~[sy,dy)̘a߂
		int sum2(int sx,int sy,int dx,int dy) const {
			int ret=0;
			dx--;dy--;
			if(dx<0 || dy<0)return 0;
			if(dx>=(int)bit_max_x)dx=bit_max_x-1;
			if(dy>=(int)bit_max_y)dy=bit_max_y-1;
			ret=sum(dx,dy);
			if(sx>0)ret-=sum(sx-1,dy);
			if(sy>0)ret-=sum(dx,sy-1);
			if(sx>0 && sy>0)ret+=sum(sx-1,sy-1);
			return ret;
		}
};

// WksNX
class coord_compresser {
	int* coords;
	size_t coords_num;
	size_t buffer_num;
	public:
		// Ww肵Ak
		void set_coords(const int* coord_array,size_t n) {
			if(n>buffer_num) {
				if(coords!=NULL)delete[] coords;
				coords=new int[n];
				buffer_num=n;
			}
			std::copy(coord_array,coord_array+n,coords);
			std::sort(coords,coords+n);
			coords_num=(int)(std::unique(coords,coords+n)-coords);
		}
		coord_compresser(): coords(NULL),coords_num(0),buffer_num(0) {}
		coord_compresser(const int* coord_array,size_t n) {
			coords=NULL;
			coords_num=0;
			buffer_num=-1;
			set_coords(coord_array,n);
		}
		~coord_compresser() {delete[] coords;}
		// w肳ꂽCfbNX̍W擾
		int operator[](size_t idx) const {return coords[idx];}
		// k̍W̐擾
		size_t size() const {return coords_num;}
		// mۂꂽobt@̃TCY擾
		size_t capacity() const {return buffer_num;}
		// w肵Ẅk̃CfbNX擾
		int indexOf(int coord) const {
			return (int)(std::lower_bound(coords,coords+coords_num,coord)-coords);
		}
};

// ň͂܂Ăꏊ𕢂`鏈{̂sNX
class square_finder {
	// vZ鎞ɂĊmۂȂĂ悤ɁAg܂킷߃oϐŎ
	virtual_2d_array<int> grid;
	coord_compresser coord_x,coord_y;
	bit_2d bit;
	int *coord_x_buf,*coord_y_buf;
	size_t buffer_size;
	public:
		square_finder(): coord_x_buf(NULL),coord_y_buf(NULL),buffer_size(0) {}
		~square_finder() {
			if(coord_x_buf!=NULL)delete[] coord_x_buf;
			if(coord_y_buf!=NULL)delete[] coord_y_buf;
		}
		// ̊mۂs
		void reserve(size_t size) {
			if(size>buffer_size) {
				if(coord_x_buf!=NULL)delete[] coord_x_buf;
				if(coord_y_buf!=NULL)delete[] coord_y_buf;
				buffer_size=size;
				coord_x_buf=new int[buffer_size*2];
				coord_y_buf=new int[buffer_size*2]; 
				grid.resize(buffer_size*4+1,buffer_size*4+1);
				bit.resize(buffer_size*2,buffer_size*2);
			}
		}
		std::vector<SQUARE*> get_squares(const std::vector<LINE*>& line);
};

// ň͂܂Ă镔Kȋ`ɕ
// ̐NƂāAO(N^2 log N)Ǝv
std::vector<SQUARE*> square_finder::get_squares(const std::vector<LINE*>& line) {
	// ȂAɋ`݂͑Ȃ
	if(line.empty())return std::vector<SQUARE*>();
	// KvȂobt@̍Ċmۂs
	reserve(line.size());
	size_t n=line.size();
	// Wk̏
	for(size_t i=0;i<n;i++) {
		if(line[i]->pos1X!=line[i]->pos2X && line[i]->pos1Y!=line[i]->pos2Y) {
			// ͂(ii)
			return std::vector<SQUARE*>();
		}
		coord_x_buf[i*2]=line[i]->pos1X;
		coord_x_buf[i*2+1]=line[i]->pos2X;
		coord_y_buf[i*2]=line[i]->pos1Y;
		coord_y_buf[i*2+1]=line[i]->pos2Y;
	}
	// Wk
	coord_x.set_coords(coord_x_buf,n*2);
	coord_y.set_coords(coord_y_buf,n*2);
	size_t x_size=coord_x.size();
	size_t y_size=coord_y.size();
	size_t grid_x_size=x_size*2+1;
	size_t grid_y_size=y_size*2+1;
	// @ŃObhɐ`
	grid.fill_all(0);
	// u
	for(size_t i=0;i<n;i++) {
		LINE& l=*line[i];
		int sx=coord_x.indexOf(std::min(l.pos1X,l.pos2X))*2+1;
		int sy=coord_y.indexOf(std::min(l.pos1Y,l.pos2Y))*2+1;
		int dx=coord_x.indexOf(std::max(l.pos1X,l.pos2X))*2+1;
		int dy=coord_y.indexOf(std::max(l.pos1Y,l.pos2Y))*2+1;
		grid[sy][sx]++;
		grid[sy][dx+1]--;
		grid[dy+1][sx]--;
		grid[dy+1][dx+1]++;
	}
	// ݐϘa
	for(size_t y=0;y<grid_y_size;y++) {
		for(size_t x=1;x<grid_x_size;x++)grid[y][x]+=grid[y][x-1];
	}
	for(size_t x=0;x<grid_x_size;x++) {
		for(size_t y=1;y<grid_y_size;y++)grid[y][x]+=grid[y-1][x];
	}
	// DTŋ`ł͂ȂꏊɈ
	std::queue<COORD> search_queue;
	search_queue.push(COORD(0,0));
	grid[0][0]=1;
	while(!search_queue.empty()) {
		static const int dx[4]={1,0,-1,0};
		static const int dy[4]={0,1,0,-1};
		COORD now_coord=search_queue.front();
		search_queue.pop();
		for(int i=0;i<4;i++) {
			int nx=now_coord.x+dx[i];
			int ny=now_coord.y+dy[i];
			if(0<=nx && nx<(int)grid_x_size && 0<=ny && ny<(int)grid_y_size && grid[ny][nx]==0) {
				grid[ny][nx]=1;
				search_queue.push(COORD(nx,ny));
			}
		}
	}
	// 󂪕tĂȂꏊɂāA񎟌BITɒl𑫂Ă
	bit.clear();
	for(size_t y=0;y<y_size;y++) {
		for(size_t x=0;x<x_size;x++) {
			if(grid[y*2+2][x*2+2]==0)bit.add(x,y,1);
		}
	}
	// 񎟌BITpċ`oAXgɑ}
	// ォEɏɃXLA×~ɋ`𖄂߂Ă
	std::vector<SQUARE*> squares;
	for(size_t y=0;y<y_size;y++) {
		for(size_t x=0;x<x_size;x++) {
			if(bit.sum2(x,y,x+1,y+1)==1) {
				size_t left,right;
				// x̓񕪒T
				left=x;right=x_size-1;
				while(left<=right) {
					size_t mid=(left+right)/2;
					if(bit.sum2(x,y,mid+1,y+1)==(int)(mid-x+1)) {
						left=mid+1;
					} else {
						right=mid-1;
					}
				}
				size_t dx=left-1;
				// y̓񕪒T
				left=y;right=y_size-1;
				while(left<=right) {
					size_t mid=(left+right)/2;
					if(bit.sum2(x,y,dx+1,mid+1)==(int)((dx-x+1)*(mid-y+1))) {
						left=mid+1;
					} else {
						right=mid-1;
					}
				}
				size_t dy=left-1;
				// `o^
				squares.push_back(new SQUARE(coord_x[x],coord_y[y],coord_x[dx+1],coord_y[dy+1]));
				// BIT獡o^`ɊY镔
				for(size_t y2=y;y2<=dy;y2++) {
					for(size_t x2=x;x2<=dx;x2++)bit.add(x2,y2,-1);
				}
			}
		}
	}
	return squares;
}

int main(void) {
	std::vector<LINE*> lines;
	std::vector<SQUARE*> squares;
	square_finder sf;
	int n;
	// ͂ǂݍ
	if(scanf("%d",&n)!=1)return 1;
	for(int i=0;i<n;i++) {
		int sx,sy,dx,dy;
		if(scanf("%d%d%d%d",&sx,&sy,&dx,&dy)!=4)return 1;
		lines.push_back(new LINE(sx,sy,dx,dy));
	}
	// vZ
	squares=sf.get_squares(lines);
	// ʂo͂
	printf("%u\n",(unsigned int)squares.size());
	for(size_t i=0;i<squares.size();i++) {
		printf("%d %d %d %d\n",
			squares[i]->pos1X,squares[i]->pos1Y,
			squares[i]->pos2X,squares[i]->pos2Y);
	}
	// 
	for(std::vector<LINE*>::iterator it=lines.begin();it!=lines.end();it++) {
		delete[] *it;
	}
	for(std::vector<SQUARE*>::iterator it=squares.begin();it!=squares.end();it++) {
		delete[] *it;
	}
	return 0;
}
